#!/usr/bin/python
# -*- coding: utf-8 -*-


import sys, os
import math

import xml.dom.minidom

os.chdir(os.path.dirname(os.path.realpath(sys.argv[0])))

import mod_globals
from   mod_utils    import *

class decu_data:

  Name                  = ""
  Comment               = ""
  Mnemonic              = ""
  Description           = ""
  Bytes                 = False
  BytesCount            = 1
  BytesASCII            = False
  Bits                  = False
  BitsCount             = 8
  signed                = False
  Binary                = False
  List                  = {}
  Scaled                = False
  Step                  = 1.0
  Offset                = 0.0
  DivideBy              = 1.0
  Format                = ""
  Unit                  = ""
  
  def __str__(self):
    
    li = ''
    for k in self.List.keys():
      li = li + '\n'+'%4s:%s'%(k,self.List[k])

    out = '''
  Name                  = %s
  Comment               = %s
  Mnemonic              = %s
  Description           = %s
  Bytes                 = %d
  BytesCount            = %d
  BytesASCII            = %d
  Bits                  = %d
  BitsCount             = %d
  signed                = %d
  Binary                = %d
  List                  = %s
  Scaled                = %d
  Step                  = %f
  Offset                = %f
  DivideBy              = %f
  Format                = %s
  Unit                  = %s 
  ''' % (self.Name, self.Comment, self.Mnemonic, self.Description, self.Bytes,
      self.BytesCount, self.BytesASCII, self.Bits, self.BitsCount, self.signed, self.Binary,
      li, self.Scaled, self.Step, self.Offset, self.DivideBy, self.Format, self.Unit)
    
    return pyren_encode(out)  
   


  def __init__(self, dt):
    self.Name  = dt.getAttribute("Name")
    #print self.Name

    self.Comment = ""
    Comment = dt.getElementsByTagName("Comment")
    if Comment: self.Comment=Comment.item(0).firstChild.nodeValue

    self.Mnemonic = ""
    Mnemonic = dt.getElementsByTagName("Mnemonic")
    if Mnemonic: self.Mnemonic=Mnemonic.item(0).firstChild.nodeValue

    self.Description = ""
    Description = dt.getElementsByTagName("Description")
    if Description: self.Description=Description.item(0).firstChild.nodeValue.replace('<![CDATA[','').replace(']]>','')

    Bytes = dt.getElementsByTagName("Bytes")
    if Bytes:
      by = Bytes.item(0)
      
      self.Bytes = True
      
      self.BytesCount = 1
      BytesCount = by.getAttribute("count")
      if BytesCount:
        self.BytesCount = int(math.ceil(float(BytesCount)))
      self.BitsCount = self.BytesCount * 8
      #print 'ByteCount', self.BytesCount

      self.BytesASCII = False
      BytesASCII = by.getAttribute("ascii")
      if BytesASCII: self.BytesASCII = True
    
    Bits = dt.getElementsByTagName("Bits")
    if Bits:
      bi = Bits.item(0)
    
      self.Bits = True
      
      self.BitsCount = 8
      BitsCount = bi.getAttribute("count")
      if BitsCount:
        self.BitsCount = int(BitsCount)
      self.BytesCount = int(math.ceil(self.BitsCount / 8.0))

      self.signed = False
      signed = bi.getAttribute("signed")
      if signed: self.signed = True
    
      self.Binary = False
      Binary = bi.getElementsByTagName("Binary")
      if Binary: self.Binary = True
     
      self.List = {}
      Items = bi.getElementsByTagName("Item")
      if Items:
        for i in Items:
          Value = int(i.getAttribute("Value"))
          Text  = i.getAttribute("Text")
          if ';' in Text: Text = Text.split(';')[0].strip()
          self.List[Value] = Text
          
      self.Scaled = False
      Scaled = bi.getElementsByTagName("Scaled")
      if Scaled:
        sc = Scaled.item(0)
        
        self.Scaled = True
        
        self.Step = 1.0
        Step = sc.getAttribute("Step")
        if Step: self.Step = float(Step) 
        
        self.Offset = 0.0
        Offset = sc.getAttribute("Offset")
        if Offset: self.Offset = float(Offset) 

        self.DivideBy = 1.0
        DivideBy = sc.getAttribute("DivideBy")
        if DivideBy: self.DivideBy = float(DivideBy) 
        
        self.Format = ""
        Format = sc.getAttribute("Format")
        if Format: self.Format = Format 

        self.Unit = ""
        Unit = sc.getAttribute("Unit")
        if Unit: self.Unit = Unit        

class decu_datas:
  def __init__(self, data_list, xdoc):
    datas = xdoc.getElementsByTagName("Data")
    if datas:
      for dt in datas:
        data = decu_data( dt )
        data_list[data.Name] = data
        #print data
        